﻿'--------------------------------------------------------------------------------------------------------------------------------------------------
'                                                    GPS Tracking integrtation with HOMESEER
' 	     				   by DJF3 - http://www.domoticaworld.com - info@domoticaworld.com
' version 0.4 - Mar 04 2013 - Have to update, current links don't work anymore
' version 0.3 - Jan 12 2012 - added link to Google Maps based on the coordinates
'				Mar 15 2012 - Track_U (last update) device now shows days in device VALUE
' version 0.2 - Oct 24 2011
'	Updated code because of change in GPS trace website. Added debug level
' version 0.1 - May 10 2010
'	Tracking integration of Xexun TK102/103 tracker and www.gps-trace.com with HomeSeer
'	HOW: Create status-only devices in HS and modify the device-codes below, 
'        run script with parameter ("Main")
'		 Set strDebug to 1 = writing to LOG INSTEAD of writing to device
'		 Set strDebug to 2 = debug level 1 + Maps and more strings
'		 Leave Track_MAPdev empty if you don't want a google MAP with location
'       TODO: 
'		- Fine-tune small Google Map in HS device
'		- Add your 'home' location
'		- Add 'what to do when your car was NOT in Home_location but now it is'

sub Main(byVal parm As Object)

dim strDebug as String = 0			'DJ: if set to 1 NO data will be written to devices
dim Track_Xdev as String = "G20"	'X 
dim Track_Ydev as String = "G21" 	'Y
dim Track_Sdev as String = "G22" 	'Speed
dim Track_Tdev as String = "G23" 	'Time last seen
dim Track_Udev as String = "G24" 	'Updated
dim Track_MAPdev as String = "G25" 	'Google Map device
dim Home_X as String	= "4.12047163645"		'Home coordinates X - not used right now
dim Home_Y as String	= "54.3999766795"		'Home coordinates Y - not used right now
dim GPSuser as String	= "username"	' Your Orange tracker username
dim MapX as Integer		= 200		' Google Map Device Width
dim MapY as Integer		= 200		' Google Map Device Height


dim varVersion as String = "0.4"
dim DataStrng as String
dim Path, Path1 as String
dim Track_X, Track_Xdata as String
dim Track_Y, Track_Ydata as String
dim Track_S, Track_Sdata as String
dim Track_T, Track_Tdata as String
dim Track_U, Track_Udata as String
dim Track_MAP as String

varVersion = "DJ_GPS_Track_" + varVersion
Path = "https://trc-api.wialon.com"
Path1 = "/wialon/locator.html?u=" & GPSuser

Try			'DJ: get DATA from Tracker website
	If strDebug >1 then hs.writelog(varVersion,"URL=" & Path & Path1)
	DataStrng = hs.GetURL(Path,Path1,False,80)
	If strDebug >1 then hs.writelog(varVersion,"DataStrng=" & DataStrng)
	If Len(DataStrng)=0 then hs.writelog (varVersion,"Unable to get data - check internet connection"):exit sub
Catch ex As Exception
	hs.writelog(varVersion,"Error at 1-Getting data (" & ex.Message & ")")
End Try



Try			'DJ: get X data from Tracker
	Track_Xdata = hs.stringitem(DataStrng,2,"units")
	If strDebug >0 then hs.writelog(varVersion,"Track_Xdata=" & Track_Xdata)
	Track_X = Trim(hs.stringitem(Track_Xdata,1,"y"))
	Track_X = Trim(hs.stringitem(Track_X,2,"x"))
	If strDebug >0 then hs.writelog(varVersion,"Track_X1=" & Track_X)
	Track_X = Mid(Track_X,4,Len(Track_X)-6)
	If strDebug > 0 then hs.writelog(varVersion,"Track_X2=" & Track_X)
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_X:</b>" & Track_X)
	If strDebug = 0 then hs.setdevicestring(Track_Xdev,Track_X,TRUE)

Catch ex As Exception
	hs.writelog(varVersion,"Error at 2-Track_X (" & ex.Message & ")")
End Try

Try			'DJ: get Y data from Tracker
	Track_Ydata = hs.stringitem(DataStrng,2,"units")
	Track_Y = hs.stringitem(Track_Ydata,2,"y")
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_Y_y:</b>" & Track_Y)
	Track_Y = hs.stringitem(Track_Y,1,"s")
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_Y_s:</b>" & Track_Y)
	Track_Y = Mid(Track_Y,4,Len(Track_Y)-6)
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_Y:</b>" & Track_Y)
	If strDebug = 0 then hs.setdevicestring(Track_Ydev,Track_Y,TRUE)
Catch ex As Exception
	hs.writelog(varVersion,"Error at 3-Track_Y (" & ex.Message & ")")
End Try

Try			'DJ: get Speed data from Tracker
	If strDebug > 0 then hs.writelog(varVersion,"<b>DataStrng</b>:" & DataStrng)
	Track_Sdata = hs.stringitem(DataStrng,2,"units")
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_Sdata2</b>:" & Track_Sdata)
	Track_S = hs.stringitem(Track_Sdata,2,"s")
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_S_s:</b>" & Track_S)
	Track_S = hs.stringitem(Track_S,1,"t")
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_S_t:</b>" & Track_S)
	Track_S = Mid(Track_S,4,Len(Track_S)-6)
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_S:</b>" & Track_S)
	If strDebug = 0 then hs.setdevicestring(Track_Sdev,Track_S,true)
Catch ex As Exception
	hs.writelog(varVersion,"Error at 4-Track_S (" & ex.Message & ")")
End Try


Try			'DJ: get Time data from Tracker
	Track_Tdata = hs.stringitem(DataStrng,2,"units")
	Track_T = hs.stringitem(Track_Tdata,2,"t")
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_T_t:</b>" & Track_T)
	Track_T = hs.stringitem(Track_T,1,"ti")
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_T_ti:</b>" & Track_T)
	Track_T = Mid(Track_T,4,Len(Track_T)-6)
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_T:</b>" & Track_T)
	If strDebug = 0 then hs.setdevicestring(Track_Tdev,Track_T,true)
Catch ex As Exception
	hs.writelog(varVersion,"Error at 5-Track_T (" & ex.Message & ")")
End Try

Try			'DJ: get last Update data from Tracker
	Track_Udata = hs.stringitem(DataStrng,2,"units")
	Track_U = hs.stringitem(Track_Udata,2,"ti")
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_U_ti:</b>" & Track_U)
	Track_U = hs.stringitem(Track_U,1,"]")
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_U_end:</b>" & Track_U)
	Track_U = Mid(Track_U,4,Len(Track_U)-5)
	If strDebug > 0 then hs.writelog(varVersion,"<b>Track_U:</b>" & Track_U)
	If strDebug = 0 then hs.setdevicestring(Track_Udev,Track_U,true)
	If strDebug = 0 then hs.setdevicevalue(Track_Udev,Cint(hs.stringitem(Track_U,1," ")))
Catch ex As Exception
	hs.writelog(varVersion,"Error at 6-Track_U (" & ex.Message & ")")
End Try

'DJ: Set devicestring of MAP device to display a small google map
Track_MAP = "<iframe width='"& MapX &"' height='"& MapY &"' frameborder='0' scrolling='no' marginheight='0' marginwidth='0' src='http://maps.google.nl/maps?q=" & Track_Y & "," & Track_X & "&ie=UTF8&z=14&t=m&output=embed'></iframe><br />Link to <a href='http://maps.google.com/maps?q=" & Track_Y & "," & Track_X & "' target='_blank'>location</a>"
If strDebug>1 and Track_MAPdev<>"" then hs.writelog(varVersion,Track_MAP)
If Track_MAPdev <> "" then hs.setdevicestring(Track_MAPdev, Track_MAP,true)



End Sub









